#include "stdafx.h"
#include "prozesse.h"
#include "prozesseDlg.h"
#include <tlhelp32.h>	//fr die Proz-Funcs

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProzesseDlg Dialogfeld

CProzesseDlg::CProzesseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProzesseDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProzesseDlg)
	m_fenster_name = _T("");
	m_prozess_name = _T("");
	m_alleprozesse = FALSE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_THC);
}

void CProzesseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProzesseDlg)
	DDX_Text(pDX, IDC_FENSTER_NAME, m_fenster_name);
	DDX_Text(pDX, IDC_PROZ_NAME, m_prozess_name);
	DDX_Check(pDX, IDC_ALLEPROZESSE, m_alleprozesse);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProzesseDlg, CDialog)
	//{{AFX_MSG_MAP(CProzesseDlg)
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PROZ_TERM, OnProzTerm)
	ON_BN_CLICKED(IDC_FENSTER_TERM, OnFensterTerm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProzesseDlg Nachrichten-Handler

BOOL CProzesseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}


HCURSOR CProzesseDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CProzesseDlg::OnProzTerm() 
{
	UpdateData(TRUE);
	PROCESSENTRY32 peProzessInfo;				//hier kommen die Prozess Infos rein
	peProzessInfo.dwSize=sizeof(PROCESSENTRY32);	//muss wohl so initialisiert werden, sagt Herr MSDN ...

	HANDLE hProzSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);	//Shot der aktuellen Prozesse
	bool bGefunden = false;
	BOOL prozesse_da = Process32First(hProzSnapshot,&peProzessInfo);	//ersten Prozess schnappen
	while(prozesse_da && bGefunden == false)
	{
		if (strstr(peProzessInfo.szExeFile, m_prozess_name) && m_prozess_name.GetLength() >=3)	//Prozessname vergleichen
			{
			if (m_alleprozesse == FALSE) bGefunden = true;	//aufhren zu suchen
			HANDLE hProzess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, peProzessInfo.th32ProcessID);	//gibt mir nen Handle zur PID
			TerminateProcess(hProzess, 0);	//auf den Handle kann man dann Terminateprocess loslassen
			}
		prozesse_da = Process32Next(hProzSnapshot,&peProzessInfo);	//nach dem nchsten proz. gucken
	}
	CloseHandle(hProzSnapshot);
	if (bGefunden == false && m_alleprozesse == FALSE) MessageBox("Kein Prozess mit \"" + m_prozess_name +  "\" im Namen gefunden oder krzer als 3 Buchstaben", "Warnung");	
}

void CProzesseDlg::OnFensterTerm() 
{
	UpdateData(TRUE);
	CWnd *fensterhandle;
	if (fensterhandle = FindWindow(NULL,m_fenster_name)) fensterhandle->SendMessage(WM_CLOSE);	//Fenstername suchen, handle->WM_CLOSE druff, tot
	else MessageBox("Fenster \"" + m_fenster_name +  "\" nicht gefunden, vertippt?", "Warnung");
}
